UNIT  MoreCOM;

//   TecSPD (DWORD)          -   
//   DwrdStop (DWORD)        -   0,    
//   ComPortNumber (INTEGER) -   COM- (0  COM1  ..)
//   ComError (INTEGER)      -  
//
//   FUNCTION  ComOpen:BOOLEAN;
//        ComPortNumber -
//     ComOpen=FALSE - -  .
//
//   FUNCTION  ExChange(VAR S:ShortString;Pr:INTEGER;Ti:DOUBLE):BOOLEAN;
//        S      
//       ,     S 
//       ,    
//     Pr -  
//     Ti -    (1.1574e-5) = 1.
//     ExChange=FALSE -      
//
//   FUNCTION  Separator(VAR CPS:ShortString;NPribor:INTEGER;VAR A:ARRAY OF ShortString;NumStr:INTEGER):BOOLEAN;
//        ,
//      ,  ,
//      ,   
//        
//     CPS -   
//     NPribor -  
//     A -       
//     NumStr -     
//
//   PROCEDURE ComClose;
//      -,  ComOpen
//
//   FUNCTION  ErrToStr(I:INTEGER):STRING;
//         
//

INTERFACE

uses  Windows, SysUtils, Forms;

CONST    MaxString=60; {   }


VAR     TecSPD:DWORD = CBR_9600;

        DwrdStop:DWORD = 0;   { 0-  / 1-. }
        ComError:INTEGER;       //    
        ComPortNumber: INTEGER; //  -
        TimeOut:       DOUBLE = 1.15e-5;  //  ;
        ANS:   ARRAY [0..(MaxString-1)] OF ShortString;

FUNCTION  ComOpen:BOOLEAN;
PROCEDURE ComClose;
FUNCTION  ExChange(VAR S:ShortString;Pr:INTEGER;Ti:DOUBLE):BOOLEAN;
FUNCTION  Separator(VAR CPS:ShortString;NPribor:INTEGER;VAR A:ARRAY OF ShortString;NumStr:INTEGER):BOOLEAN;
FUNCTION  ErrToStr(I:INTEGER):STRING;


IMPLEMENTATION

VAR DataControl:TDCB;
    DataWait:TCOMMTIMEOUTS;
    ComPortFile:THandle = 0;
    St,Chislo:ShortString;
    StBUF:ARRAY [0..255] OF BYTE absolute St;
    MS:   ARRAY [0..255] OF BYTE;

PROCEDURE KSUM(VAR K:WORD;B:BYTE);
VAR     I:INTEGER;
BEGIN
  K:=K XOR B;
  FOR I:=1 TO 8 DO IF (K MOD 2)=0 THEN K:=(K DIV 2)
                                  ELSE K:=(K DIV 2)XOR 40961;
END;

FUNCTION ComOpen:BOOLEAN;
LABEL EXB5,EXB6,EXB21;
BEGIN
   Result:=FALSE;
   ComPortFile:=CreateFile(PChar('COM'+IntToStr(ComPortNumber+1)+#0),GENERIC_READ+GENERIC_WRITE,0,NIL,OPEN_EXISTING,0,0);
   IF ComPortFile=INVALID_HANDLE_VALUE THEN GOTO EXB5;
   IF GetFileType(ComPortFile)<>FILE_TYPE_CHAR THEN GOTO EXB21;
   IF NOT SetupComm(ComPortFile,300,300) THEN GOTO EXB6;
    DataControl.DCBlength:=SizeOf(DataControl);
    DataControl.BaudRate:=TecSPD;
    DataControl.Flags:=1+16+4096;
    DataControl.wReserved:=0;
    DataControl.XonLim:=0;
    DataControl.XoffLim:=1299;
    DataControl.ByteSize:=8;
    DataControl.Parity:=NOPARITY;
    DataControl.StopBits:=ONESTOPBIT;
    DataControl.XonChar:=CHR(0);
    DataControl.XoffChar:=CHR(0);
    DataControl.ErrorChar:=CHR(0);
    DataControl.EofChar:=CHR(0);
    DataControl.EvtChar:=CHR(0);
   IF NOT SetCommState(ComPortFile,DataControl)    THEN GOTO EXB6;
    DataWait.ReadIntervalTimeout:=MAXDWORD;
    DataWait.ReadTotalTimeoutMultiplier:=0;//MAXDWORD;
    DataWait.ReadTotalTimeoutConstant:=0;//5;
    DataWait.WriteTotalTimeoutMultiplier:=50;
    DataWait.WriteTotalTimeoutConstant:=100;//1500;
   IF NOT SetCommTimeouts(ComPortFile,DataWait)    THEN GOTO EXB6;
   IF NOT EscapeCommFunction(ComPortFile,SETRTS)   THEN GOTO EXB6;
   IF NOT EscapeCommFunction(ComPortFile,CLRDTR)   THEN GOTO EXB6;
   IF NOT EscapeCommFunction(ComPortFile,CLRBREAK) THEN GOTO EXB6;
          PurgeComm(ComPortFile,PURGE_RXCLEAR);
      Result:=TRUE;EXIT;
EXB5: ComError:=5;EXIT;{     COM-  }
EXB6: CloseHandle(ComPortFile);ComPortFile:=0;
      ComError:=6;EXIT;{   COM- }
EXB21:CloseHandle(ComPortFile);ComPortFile:=0;
      ComError:=21;EXIT;{     - }
END;

PROCEDURE ComClose;
BEGIN
 IF ComPortFile<>0 THEN CloseHandle(ComPortFile);
    ComPortFile:=0;
END;

FUNCTION TSTSYM1(G:CHAR):BOOLEAN;
BEGIN
 CASE G OF
  '0','1','2','3','4','5','6','7','8','9','-','.':TSTSYM1:=TRUE;
  ELSE  TSTSYM1:=FALSE;
 END;
END;

FUNCTION TSTSYM2(G:CHAR):BOOLEAN;
BEGIN
 CASE G OF
  '0','1','2','3','4','5','6','7','8','9','-','.','$':TSTSYM2:=TRUE;
  ELSE  TSTSYM2:=FALSE;
 END;
END;


FUNCTION  Separator(VAR CPS:ShortString;NPribor:INTEGER;VAR A:ARRAY OF ShortString;NumStr:INTEGER):BOOLEAN;
VAR      I:INTEGER;
   RPribor:INTEGER;
     S1,S2:INTEGER; {      KS }
       KS0:DWORD;
        KS:WORD;
       CER:INTEGER;
         K:INTEGER;
 BEGIN
  Separator:=FALSE;
  IF NumStr>MaxString THEN EXIT;
  I:=1;
  WHILE ((I<=Length(CPS)) AND (CPS[I]<>'!')) DO I:=I+1;
  I:=I+1;IF I>Length(CPS)   THEN EXIT;
  S1:=I;
{     }
  Chislo:='';
  WHILE TSTSYM1(CPS[I]) DO
   BEGIN
    Chislo:=Chislo+CPS[I];
    I:=I+1;IF I>Length(CPS) THEN EXIT;
   END;
  VAL(Chislo,RPribor,CER);I:=I+1;
  IF ((CER<>0) OR (CPS[I-1]<>';') OR (I>Length(CPS))) THEN EXIT;
  IF NPribor<>RPribor THEN EXIT;
{    }
  FOR K:=0 TO (NumStr-1) DO
  BEGIN
   A[K]:='';
   WHILE TSTSYM2(CPS[I]) DO
    BEGIN
     A[K]:=A[K]+CPS[I];
     I:=I+1;IF I>Length(CPS) THEN EXIT;
    END;
   I:=I+1;
   IF ((CPS[I-1]<>';') OR (I>Length(CPS))) THEN EXIT;
  END;
  S2:=I-1;
{     }
  Chislo:='';
  WHILE TSTSYM1(CPS[I]) DO
   BEGIN
    Chislo:=Chislo+CPS[I];
    I:=I+1;IF I>Length(CPS) THEN EXIT;
   END;
  VAL(Chislo,KS0,CER);
  IF(CER<>0)OR(CPS[I]<>CHR(13)) THEN EXIT;
{      }
  KS:=65535;
  FOR I:=S1 TO S2 DO KSUM(KS,ORD(CPS[I]));
  IF KS<>KS0          THEN EXIT;
  Separator:=TRUE;
 END;


FUNCTION  ErrToStr(I:INTEGER):STRING;
BEGIN
 CASE I OF
 0:   ErrToStr:=' ';
 5:   ErrToStr:='    COM-';
 6:   ErrToStr:='  COM-';
 7:   ErrToStr:=' ';
 9:   ErrToStr:=' ';
 10:  ErrToStr:='  ';
 15:  ErrToStr:='  ';
 16:  ErrToStr:='   COM-';
 17:  ErrToStr:='  '; // DwrdStop<>0
 18:  ErrToStr:='   COM-';
 21:  ErrToStr:='COM-  ';
 ELSE ErrToStr:='   '+IntToStr(I);
 END;
END;

FUNCTION  ExChange(VAR S:ShortString;Pr:INTEGER;Ti:DOUBLE):BOOLEAN;
VAR W,K:DWORD;
    BitStart,BitEnd:BOOLEAN;
    KS:WORD;
    TM:DOUBLE;
    Le:DWORD;
LABEL EXB1;
BEGIN
 Result:=FALSE; ComError:=0;
 IF (Length(S)>240)OR(Pr<0)OR(Pr>254) THEN
  BEGIN
   ComError:=19;EXIT;
  END;
 St:=#255+':'+IntToStr(Pr)+';'+S;  // #255 -         
 KS:=65535;
 FOR W:=3 TO Length(St) DO KSUM(KS,ORD(St[W]));
 St:=St+IntToStr(KS)+CHR(13);
 Le:=Length(St);
 Application.ProcessMessages;
 IF DwrdStop<>0 THEN EXIT;
 IF (NOT WriteFile(ComPortFile,StBUF[1],Le,W,NIL))OR(W<>Le) THEN
  BEGIN
   ComError:=16;EXIT;
  END;

 TM:=Now;
 BitStart:=FALSE;
 BitEnd:=FALSE;
 St:='';

REPEAT
 Application.ProcessMessages;
 IF DwrdStop<>0 THEN EXIT;
 IF NOT ReadFile(ComPortFile,MS,240,W,NIL) THEN
  BEGIN
   ComError:=18;EXIT;
  END ELSE
  BEGIN
   IF W>0 THEN
    BEGIN
     IF NOT BitStart THEN
      BEGIN
       K:=0;WHILE (K<W)AND(MS[K]<>ORD('!')) DO K:=K+1;
       IF (MS[K]=ORD('!'))AND(K<W) THEN
       BitStart:=TRUE;
      END ELSE K:=0;
     WHILE (K<W)AND(Length(St)<250) DO
      BEGIN
       St:=St+CHR(MS[K]);
       IF MS[K]=13 THEN BEGIN K:=W;BitEnd:=TRUE;END;
       K:=K+1;
      END;
     IF Length(St)>=250 THEN
      BEGIN
       ComError:=15; //   
       EXIT;
      END;
    END;
  END;
UNTIL (Now>(TM+TI))OR BitEnd;

    IF NOT BitEnd THEN
     BEGIN
      IF ComError=0 THEN
       BEGIN
        IF BitStart THEN ComError:=7  //  
        ELSE             ComError:=9; //  
       END;
      EXIT;
     END;
S:=St;
Result:=TRUE
END;

{----------------------------------------------------------}

END.
